#!/bin/sh
#
# THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
# 5724-X89 (C) COPYRIGHT International Business Machines Corp., 2011
# All Rights Reserved * Licensed Materials - Property of IBM
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.

currentDir=`pwd`
chmod +x $currentDir/*
if [ -f /etc/virtualimage.properties ]; then
    . /etc/virtualimage.properties
fi

VE_ID_FILE=$WAS_INSTALL_ROOT/properties/version/WXDOP.product
HIDDEN_VE_ID_FILE=$WAS_INSTALL_ROOT/properties/version/WXDOP.product.
XD_TEMPLATE_HIDDEN_DIR=$WAS_INSTALL_ROOT/profileTemplates/.xd_augment
TO_DISABLE_IMP=false
result=0

OS=`uname -s`
process=`uname -p`
chmod 755 $currentDir/ve_s390.sh

ps -ef|grep WebSphere > $currentDir/wasps
grep "/opt/IBM/WebSphere/AppServer/java/bin/java" $currentDir/wasps
isJavaProcessRunning=$?
if [ $isJavaProcessRunning -eq 0 ] ; then
    echo "A WebSphere java process is running.  Stop the process then apply this fix again."
    rm -f $currentDir/wasps
    exit
fi
rm -f $currentDir/wasps

if [ "$process" == "s390x" ]; then
   if  [ -f $VE_ID_FILE -a -d $XD_TEMPLATE_HIDDEN_DIR ]; then
      echo "IMP is enabled but .xd_augment exists.  Run the special version of vs_s390.sh."
      $currentDir/ve_s390.sh "enable"
      echo "Apply iFix completed"
      exit
   fi
fi                   

if [ -z $ADVANCED_FEATURE_SELECTED ]; then
   echo "The VE product file does not exist, exiting the script"
   exit    
elif [ -f $HIDDEN_VE_ID_FILE ]; then
   echo "Enable IMP prior to applying the service pack."
   $OPERATION_COMMAND_LOCATION/ve.sh "enable"
   TO_DISABLE_IMP=true
fi   

HV_USER=`cat $PROFILE_ROOT/.ibm/username`
if [ -z "$HV_USER" ]; then
    HV_USER=virtuser
fi
case "$OS" in
      "AIX")	
		echo "Current OS is AIX; set group to usr"
		HV_GROUP=usr
	;;
	*)
		echo "Current OS is $OS; set group to users"
		HV_GROUP=users
	;;
esac

if [ $OS == "AIX" ] ; then
   /usr/sbin/slibclean
   su $HV_USER -c "$WAS_INSTALL_ROOT/UpdateInstaller/update.sh -silent -W maintenance.package=\"$currentDir\" -W update.type=\"install\" -W product.location=\"$WAS_INSTALL_ROOT\" -OPT disableNonBlockingPrereqChecking=\"true\" -P wsglobalinstallconstantsProductBean.backup=\"true\" -OPT disableDiskSpaceCheck=\"true\" -OPT rootUserHasRunSlibcleanCommandSuccessfully=\"true\""
else
   su $HV_USER -c "$WAS_INSTALL_ROOT/UpdateInstaller/update.sh -silent -W maintenance.package=\"$currentDir\" -W update.type=\"install\" -W product.location=\"$WAS_INSTALL_ROOT\" -OPT disableNonBlockingPrereqChecking=\"true\" -P wsglobalinstallconstantsProductBean.backup=\"true\" -OPT disableDiskSpaceCheck=true"
fi
((result=$result || $?))
echo "Completed IMP ifixes install with result $result"

chown -hR $HV_USER:$HV_GROUP $currentDir/99defaultElasticityPolicies.ant
mv $currentDir/99defaultElasticityPolicies.ant $WAS_INSTALL_ROOT/profileTemplates/xd_augment/actions/99defaultElasticityPolicies.ant

if [ "$process" == "s390x" ]; then
   cp $currentDir/ve.sh $OPERATION_COMMAND_LOCATION/ve.sh
   chown -hR $HV_USER:$HV_GROUP $OPERATION_COMMAND_LOCATION/ve.sh
   chmod +x $OPERATION_COMMAND_LOCATION/ve.sh
fi  
  
if [ $TO_DISABLE_IMP == "true" ]; then
   echo "Disable IMP after applying the service pack."
   $OPERATION_COMMAND_LOCATION/ve.sh "disable"   
fi   

cd $currentDir

echo "Apply iFix completed"
